/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.*; 
import javax.swing.*;

/**
 * classe de couplage du module amont d'absortion de CO2 dans du mthanol
 * 
 * @author Renaud GICQUEL
 */
public class MethanolAbsorInlet extends ExtMixer 
{
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
    
    double TamontAir, PamontAir, TamontFuel, PamontFuel;

    String linkProcess,inletMethanolProcess,inletDrySynGasProcess;
    String linkPoint,inletMethanolPoint,inletDrySynGasPoint;
    
    double[]inletDrySynGasFractmol;
    String[]inletDrySynGasComp;
    double[]inletMethanolFractmol;
    String[]inletMethanolComp;
    
    MethanolAbsorOutlet outletMethanolAbsor;
    String outletMethanolAbsorName="";
    
    Vector inputFuelComp,inputDrySynGasComp;
    double drySynGasFlow,drySynGasM,methanolFlow,methanolM,Htot;
    double fractCO2,fractH2O;
    
    public MethanolAbsorInlet (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel10.setText("settings and calculations are made from the outlet component frame");
		JPanel1.add(JLabel10);
		JLabel10.setBounds(0,22,400,20);
		type=getCompType();
		thermoCouplerTypes=new String[0];
    }
    
    public void init(){
	    getMixerStructure();
        checkConsistency();
		setupOutletNode();
    }
    
    public String getCompType(){
        return "methanol absorber inlet";
    }
    
	public void calculateProcess(){//on vrifie toujours la cohrence
	    getMixerStructure();
        checkConsistency();
	}
    
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        inletMethanolProcess="";
        inletDrySynGasProcess="";
        Htot=0;
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String aval=(String)vBranch[j].elementAt(2);//gets the downstream point name
	            getPointProperties(aval);//direct parsing of point property vector
	            lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
                getSubstProperties(nomCorps);
                String nom=nomCorps;
                if(typeSubst==4){//le corps d'entre est un gaz compos
                    Vector vComp=lecorps.getGasComposition();
	                if(Util.contains(vComp,"CO2")){
	                    inletDrySynGasProcess=nomBranche[j];
	                    inletDrySynGasPoint=aval;
	                }
                }
	            else if(nom.equals("methanol-CO2 mixture")){
	                inletMethanolProcess=nomBranche[j];
	                inletMethanolPoint=aval;
	            }
	            else{//le corps d'entre n'est ni un gaz compos ni du methanol-CO2 mixture
	                String msg = "Error: the inlet substance is not of the right type";
	                JOptionPane.showMessageDialog(me, msg);  
	            }
	        }
	        if((inletDrySynGasProcess.equals(""))||(inletMethanolProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(me, msg);  
	            isBuilt=false;
	        }
        }
        //initialisations relatives  drySynGas
        args=new String[2];
        args[0]="process";
        args[1]=inletDrySynGasProcess;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        drySynGasFlow=f.doubleValue();//dbit du gaz  traiter
        String aval=(String)vProp.elementAt(2);
        getPointProperties(aval);
        TamontAir=Tpoint;//temprature d'entre de l'drySynGas
        PamontAir=Ppoint;//pression d'entre de l'drySynGas
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputDrySynGasComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractCO2=Util.molarComp(inputDrySynGasComp,"CO2");//fraction molaire de O2
        fractH2O=Util.molarComp(inputDrySynGasComp,"H2O");//fraction molaire de O2
        drySynGasM=Msubst;//masse molaire du gaz  traiter
        Htot=Hsubst*drySynGasFlow;
        //chargement du tableau des fractions molaires du gaz  traiter
        Integer i=(Integer)inputDrySynGasComp.elementAt(0);
	    int nComp=i.intValue(); 
        inletDrySynGasComp= new String[nComp];
        Double[]fracMol= new Double[nComp];
        inletDrySynGasFractmol= new double[nComp];
	    inletDrySynGasComp=(String[])inputDrySynGasComp.elementAt(1);
	    fracMol=(Double[])inputDrySynGasComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletDrySynGasFractmol[j]= fracMol[j].doubleValue();
        }
        
        //initialisations relatives au gaz inletMethanol
        args=new String[2];
        args[0]="process";
        args[1]=inletMethanolProcess;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(3);
        methanolFlow=f.doubleValue();//dbit du gaz inletMethanol
        aval=(String)vProp.elementAt(2);
        getPointProperties(aval);
        TamontFuel=Tpoint;//temprature d'entre de l'drySynGas
        PamontFuel=Ppoint;//pression d'entre de l'air
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        
        Htot=Htot+methanolFlow*Hpoint;
        
        //initialisations relatives  la transfo-point de liaison
        linkProcess=mainProcess;
	    args[0]="process";
	    args[1]=linkProcess;
	    Vector vPropMain=proj.getProperties(args);
	    aval=(String)vPropMain.elementAt(2);
	    getPointProperties(aval);
	    linkPoint=aval;
    }
    
    void setupOutletNode(){
        Vector vExt=proj.getExternalClassInstances();
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        String type=(String)obj[0];
	        if(type.equals("node")){
	            String main=(String)obj[4];
	            String nodeType=(String)obj[3];
	            if((main.equals(linkProcess))&&((nodeType.equals("methanol absorber outlet")))){
	                outletMethanolAbsor=(MethanolAbsorOutlet)obj[1];
	                outletMethanolAbsorName=(String)obj[2];
	            }
	        }
        }
    }


}