/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.*; 
import javax.swing.*;

/**
 * classe de rgnration du mthanol
 * 
 * @author Renaud GICQUEL
 */
public class MethanolRegen extends ExtDivider
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField condenserLoad_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField epsi_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Q_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Compr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P, XInletMethanol, TInletMethanol, HInletMethanol, richSolutionFlow;
    String richSolutionProcess,CO2Process,poorSolutionProcess,poorSolutionSubstanceName,CO2SubstanceName;
    String richSolutionPoint,CO2Point,poorSolutionPoint;
    rg.corps.Corps poorSolutionSubstance;
    rg.corps.Corps CO2Substance;
    
    String outletMethanolAbsorName="";
    
    double epsi,tau;
    
    public MethanolRegen (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("efficiency");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(epsi_value);
		epsi_value.setBounds(164,0,100,20);
		epsi_value.setText("0.5");
		JLabel2.setText("condenser load");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,164,20);
		JPanel1.add(condenserLoad_value);
		condenserLoad_value.setBounds(164,24,100,20);
		condenserLoad_value.setText("0.5");
		JLabel3.setText("boiler heat");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
		JPanel1.add(Q_value);
		Q_value.setBounds(164,48,100,20);
		Q_value.setText("0");
		JLabel4.setText("compression power");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
		JPanel1.add(Compr_value);
		Compr_value.setBounds(164,72,100,20);
		Compr_value.setText("0");
		JLabel5.setText("CO2 temperature (C)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,164,20);
		JPanel1.add(Tout_value);
		Tout_value.setBounds(164,96,100,20);
		Tout_value.setText("0");
		type=getCompType();
		thermoCouplerTypes=new String[2];
 		thermoCouplerTypes[0]="boiling heat";
		thermoCouplerTypes[1]="-30 C methanol condenser";
    }
    public void init(){
	    getDividerStructure();
        checkConsistency();
    }
    
    public String getCompType(){
        return "methanol regenerator";
    }
    
	public void calculateProcess(){
	
	    getDividerStructure();
        checkConsistency();
	    
	    if(isBuilt){//si le noeud externe est bien configur
	    
	        //Dtermination du taux de sparation du CO2 dans l'absorbeur
	        //par inversion de la rgression donnant xMethanol
  //          double xMethanolCalc=-0.159185507*epsi*epsi+0.406453329*epsi-0.100311563;//valeurs massiques
            double a=-0.159185507,b=0.406453329,c=-0.100311563;
            c=c-XInletMethanol;
	        double delta=b*b-4*a*c;
	    //    double epsi1=(-b-Math.pow(delta, 0.5))/2./a;
	        epsi=(-b+Math.pow(delta, 0.5))/2./a;

            //dbit massique de CO2 spar
            double CO2flow=richSolutionFlow*XInletMethanol;
	        
            //estimations par rgression
	        double Qboiling=(495554804.2*epsi*epsi-859232517.5*epsi+374400680.9)/1000;//100 C = 373 K
            double methanolCondenser=-(229198308.8*epsi*epsi-373766036.4*epsi+152257174.1)/1000;//33 C = 306 K
            double wMethanolCompr=(13876026.17*epsi*epsi-23590729.28*epsi+11669968.31)/1000;//33 C = 306 K
            double TCO2=64.35722868*epsi*epsi-108.2182619*epsi+16.50616741;
            
            //les tempratures d'entre et de sortie du rebouilleur sont dtermines par rapport 
            // celle de sortie du pied de colonne
            double TpiedCol=601.8822588*epsi*epsi-531.5446537*epsi+5.238326043;
            
            //affichages  l'cran
            Compr_value.setText(Util.aff_d(wMethanolCompr,2));
            Q_value.setText(Util.aff_d(Qboiling,2));
            condenserLoad_value.setText(Util.aff_d(methanolCondenser,2));
            Tout_value.setText(Util.aff_d(TCO2,2));
            epsi_value.setText(Util.aff_d(epsi,2));

            //mise  jour des thermocoupleurs, comme pinchFluid, DTmin=10
	        updateThermoCoupler("boiling heat", 273+TpiedCol, 283+TpiedCol, Qboiling, richSolutionFlow,true,10);
	        updateThermoCoupler("-30 C methanol condenser", 248, 238, methanolCondenser, richSolutionFlow,true,10);
	   
	        //mise  jour du noeud en utilisant les mthodes gnriques
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(CO2Process, CO2Point, 0, CO2flow, TCO2+273, 1.2, 1);
	        setupVector(poorSolutionProcess, poorSolutionPoint, 1, richSolutionFlow-CO2flow, 249, 23.5, 0);
	        setupVector(richSolutionProcess, richSolutionPoint, 2, richSolutionFlow, TInletMethanol, 23.5, XInletMethanol);
            updateDivider(vTransfo,vPoints,TInletMethanol,HInletMethanol*richSolutionFlow);
            //le travail de compression est pris en compte comme nergie utile dans la transfo-point richSolutionProcess
	        de.updateProcess(setEnergyTypes(richSolutionProcess,wMethanolCompr,0,0));
        }

	}
	
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        CO2Process="";
        poorSolutionProcess="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 3";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                String nom=nomCorps;
                if(typeSubst==3){//le corps d'entre est un gaz pur

                    //Check the substance at outlet
	                if(nom.equals("CO2")){
	                    CO2Process=nomBranche[j];
	                    CO2Point=amont;
	                }
	            }
	            else if(nom.equals("methanol-CO2 mixture")){
	                poorSolutionProcess=nomBranche[j];
	                poorSolutionPoint=amont;
	            }
	            else{//le corps de sortie n'est ni du CO2 ni du methanol-CO2 mixture
	                String msg = "Error: the outlet substance is not of the right type";
	                JOptionPane.showMessageDialog(de, msg);  
	            }
	        }
	        if((CO2Process.equals(""))||(poorSolutionProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        richSolutionProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=richSolutionProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    richSolutionFlow=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
	    richSolutionPoint=aval;
	    XInletMethanol=Xpoint;
	    TInletMethanol=Tpoint;
	    HInletMethanol=Hpoint;
        String nom=nomCorps;
        //Check the substance at inlet
	    if(!(nom.equals("methanol-CO2 mixture"))){
	        String msg = "Error on main process substance,which is "+nomCorps+" instead of methanol-CO2 mixture";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
	    }
        
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "condenserLoad_value");
        double condenserLoad=0;
        if(valeur!=null)condenserLoad=Util.lit_d(valeur);
	    condenserLoad_value.setText(Util.aff_d(condenserLoad,3));
		double Tout=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tout,2));
		double Q=Util.lit_d(Util.extr_value(ligne_data, "Q_value"));
	    Q_value.setText(Util.aff_d(Q,2));
		double current=Util.lit_d(Util.extr_value(ligne_data, "Compr_value"));
	    Compr_value.setText(Util.aff_d(current,2));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"condenserLoad_value="+condenserLoad_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"Q_value="+Q_value.getText()+tab
	    +"Compr_value="+Compr_value.getText()+tab
	    ;
        return h;
    }
}